﻿using System.IO;
using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace post12529
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            LayerOverlay overlay = new LayerOverlay();
            var tiffFiles = Directory.GetFiles(@"C:\Test\hp\hp", "*.tif");
            RectangleShape rect = null;
            foreach (var item in tiffFiles)
            {
                GdiPlusRasterLayer rasterLayer = new GdiPlusRasterLayer(item);
                rasterLayer.Open();
                if (rect == null)
                {
                    rect = rasterLayer.GetBoundingBox();
                }
                else
                {
                    rect = rect.Union(rasterLayer.GetBoundingBox()).GetBoundingBox();
                }
                rasterLayer.Close();
                overlay.Layers.Add(rasterLayer);
            }

            InMemoryFeatureLayer featureLayer = new InMemoryFeatureLayer();
            featureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            MultipolygonShape multiPolygon = new MultipolygonShape("MULTIPOLYGON(((447350.068099358 1204353.22865865,447044.32075099 1204993.38716929,447350.068099358 1205824.63777267,447665.370052363 1205805.5285634,447627.151633817 1205260.91609912,447990.226610004 1205557.10884285,447990.226610004 1204658.97600702,447350.068099358 1204353.22865865)))");

            for (int i = 0; i < 50; i++)
            {
                MultipolygonShape multiPolygon1 = (MultipolygonShape)multiPolygon.CloneDeep();
                multiPolygon1.TranslateByOffset(400 * i, 0);
                Feature singleFeature = new Feature(multiPolygon1);
                featureLayer.InternalFeatures.Add(singleFeature);
            }

            overlay.Layers.Add(featureLayer);
            overlay.TileCache = new FileBitmapTileCache(@"C:\temp\wpfcaches");
            Map1.MapUnit = GeographyUnit.Meter;
            Map1.CurrentExtent = rect;
            Map1.Overlays.Add(overlay);
            Map1.Refresh();
        }
    }
}
